#! /bin/sh
#
# By C.Lippmann
#

. _setup.sh

usage() {
    echo ""
    echo "Usage : ./power_all.sh all   -> to power on all boards in SM"
    echo "        ./power_all.sh off   -> to power off all boards in SM"
    echo "        ./power_all.sh cycle -> to power cycle all boards in SM"
    echo "        ./power_all.sh read  -> read status of all boards in SM"
    echo ""
    exit;
}

if [ $# -ne 1 ]; then
    usage;
fi

PAR=$1

if [ $PAR == "all" ] || [ $PAR == "off" ] || [ $PAR == "cycle" ] || [ $PAR == "read" ]; then

    echo "Going to power $PAR ROBs in Supermodule ..."

    for P in $POS_LIST ; do
	DCS=`./modules/getdcsbypos.pl $P`
	ssh $DCS "/usr/local/sbin/rob_power $PAR; echo \"\"" &
    done

    wait

    echo "Finished."
else
    usage;
fi
