#! /bin/sh
# 
# Change PASACHM dynamically
# 

if [ $# -ne 2 ]; then
    echo ""
    echo "  Usage: set_chpasa.sh pattern host"
    echo ""
    exit;
fi

PATTERN=$1
HOST=$2
TEMPFILE_DCS=/dcsnfs/ROC_Test/_set_pasachm_temp.dat
TEMPFILE_LOCAL=~/$TEMPFILE_DCS
let NUMLINK=$ROC_TYPE+3

echo "$HOST sits on Type C$ROC_TYPE ROC with $NUMLINK LinkPairs."

# Create patch file

ssh $HOST "/usr/local/sbin/ttcrx_regs s"

if [ x$PATTERN == "xeven" ]; then
tcc <<EOF > $TEMPFILE_LOCAL
write PASACHM, 0x00001
write PASAPR1, 0
write PASAPR1, 1
wait 100
pretrigger 2
write PASAPR1, 0
write PASAPR1, 1
wait 100
write PASAPR1, 0
pretrigger 2
EOF
elif [ x$PATTERN == "xodd" ]; then
tcc <<EOF > $TEMPFILE_LOCAL
write PASACHM, 0xAAAAA
write PASAPR1, 0
write PASAPR1, 1
wait 100
pretrigger 2
write PASAPR1, 0
write PASAPR1, 1
wait 100
write PASAPR1, 0
pretrigger 2
EOF
else 
echo "This pattern <$PATTERN> is not supported."
exit 1
fi

ssh $HOST "/usr/local/sbin/pretrigger 2; /usr/local/sbin/pretrigger 2"

# Send patch

LINKPAIR=0
LINK=0         # always use link 0

while [  $LINKPAIR -lt $NUMLINK ]; do
    echo ""
    echo "########################################################################"
    echo "${HOST}: dcs2trap -link ${LINKPAIR} 0 -q -i ${TEMPFILE_DCS}"
    echo "########################################################################"
    echo ""
    ssh $HOST "killall dcs2trap" > /dev/null 2>&1
    ssh $HOST "/usr/local/sbin/dcs2trap -link $LINKPAIR $LINK -i ${TEMPFILE_DCS}"
    let LINKPAIR=LINKPAIR+1 
done

ssh $HOST "/usr/local/sbin/pretrigger 5"
echo "::"
echo ":: Chamber ($HOST) is patched."
echo "::" `date`
echo ""

rm -f $TEMPFILE

# EOF
