#! /bin/sh
# 
# Send necessary patches

POS=$1
HOST=`./modules/getdcsbypos.pl $POS`
DC_NAME=`./modules/getinfobypos.pl $POS rocname`
DC_TYPE=`./modules/getinfobypos.pl $POS ctype`

echo Send Header to $DC_NAME $DC_TYPE 

HEADER_TCS=headers/header_$POS.tcs
TEMP_DATX=/dcsnfs/SM_Test/headers/temp_header_$POS.datx
TEMP_DAT=/dcsnfs/SM_Test/headers/temp_header_$POS.dat

LINKPAIR=2
LINK=0
rm -f $TEMP_DATX $TEMP_DAT  ; # Cleanup
echo ""

# Create Header TCS
echo Creating Header TCS...
./gen_header_tcs.pl $POS > $HEADER_TCS
echo Compiling...
tcc ~/dcsnfs/ROC_Test/scsn_ids.tcs $HEADER_TCS  >> $TEMP_DATX

echo ""

if [ ! -s $TEMP_DATX ]; then
    echo "$TEMP_DATX is empty. Something Strange."
    exit
fi

echo "The DATX to be downloaded:"
echo "----"
cat $TEMP_DATX
echo "----"

echo ""
echo "==== Linkpair $LINKPAIR ===="
echo ""
dat_expander $LINKPAIR $DC_TYPE $TEMP_DATX $TEMP_DAT
echo ""
if [  -s $TEMP_DAT ]; then
    ssh $HOST "killall dcs2trap" > /dev/null 2>&1
    ssh $HOST "/usr/local/sbin/dcs2trap -link $LINKPAIR $LINK -i ${TEMP_DAT}"
else
    echo "  ---- No patch needed ----"
fi

#rm -f $TEMP_DAT $TEMP_DATX

echo ""
echo ":: Chamber ($HOST) has header now."
echo "::" `date`

echo ""

# EOF
