#! /bin/sh
# 
# Send necessary patches

POS=$1
HOST=`./modules/getdcsbypos.pl $POS`
DC_NAME=`./modules/getinfobypos.pl $POS rocname`
DC_TYPE=`./modules/getinfobypos.pl $POS ctype`

echo Patch $DC_NAME $DC_TYPE 

PATCH_DATX=patches/patch_$DC_NAME.datx
PATCH_TCS=patches/patch_$DC_NAME.tcs
TEMP_DATX=/dcsnfs/SM_Test/patches/temp_patch_$DC_NAME.datx
TEMP_DAT=/dcsnfs/SM_Test/patches/temp_patch_$DC_NAME.dat

let NUMLINK=$DC_TYPE+3
if [ $DC_TYPE -eq 0 ]; then
    NUMLINK=3  # NUMLINK=3 for C0 chambers
fi

LINKPAIR=0
LINK=0
rm -f $TEMP_DATX $TEMP_DAT  ; # Cleanup
echo ""

# Look for datx
if [ -r $PATCH_DATX ]; then
    echo "$PATCH_DATX ... Found."
    cp $PATCH_DATX $TEMP_DATX
else
    echo "$PATCH_DATX ... Not found."
fi

# Look for tcs
if [ -r $PATCH_TCS ]; then
    echo "$PATCH_TCS  ... Found."
    tcc ~/dcsnfs/ROC_Test/scsn_ids.tcs $PATCH_TCS  >> $TEMP_DATX
else
    echo "$PATCH_TCS  ... Not found."
fi

echo ""

if [ ! -s $TEMP_DATX ]; then
    echo "Patch is empty. Do nothing."
    exit
fi

echo "The patch to be downloaded:"
echo "----"
cat $TEMP_DATX
echo "----"


while [  $LINKPAIR -lt $NUMLINK ]; do
    echo ""
    echo "==== Linkpair $LINKPAIR ===="
    echo ""
    dat_expander $LINKPAIR $DC_TYPE $TEMP_DATX $TEMP_DAT
    echo ""
    if [  -s $TEMP_DAT ]; then
	ssh $HOST "killall dcs2trap" > /dev/null 2>&1
	ssh $HOST "/usr/local/sbin/dcs2trap -link $LINKPAIR $LINK -i ${TEMP_DAT}"
    else
	echo "  ---- No patch needed ----"
    fi
    let LINKPAIR=LINKPAIR+1 
done

rm -f $TEMP_DAT $TEMP_DATX
echo ""
echo ":: Chamber ($HOST) is patched."
echo "::" `date`

echo ""

# EOF
