#! /bin/sh
# 
# Shutdown test on chamber.
# Chamber data is read from "_setup".
# By C. Lippmann and K. Oyama
#

HOST=$1
#LINKPAIR=
#LINK=


do_ping() {

    LINKPAIR=0
    while [ $LINKPAIR -lt $NUMLINK ]; do
	echo ""
	echo "${HOST}: dcs2trap -link ${LINKPAIR} ${LINK} -p 3" | tee -a $LOGFILE
	ssh $HOST "/usr/local/sbin/dcs2trap -link $LINKPAIR $LINK -p 3" | tee -a $LOGFILE
	let LINKPAIR=LINKPAIR+1
    done

}


MESSAGE1=( "Switch off all ROBs on chamber ..."
           "Switch on ROBs on linkpair 2 (halfchamber mergers with clock distribution here) ..."
           "Switch on ROBs on linkpairs 0 and 2 ..."
           "Switch on ROBs on linkpairs 1 and 2 ..."
           "Switch on ROBs on linkpairs 2 and 3 ..." )

MESSAGE2=( "All links should be dead"
           "Only linkpair 2 should be alive"
           "Only linkpairs 0 and 2 should be alive"
           "Only linkpairs 1 and 2 should be alive"
           "Only linkpairs 2 and 3 should be alive" )

POWERVAL=( "off"
           "0 0 0 0 1 1 0 0"
	   "1 1 0 0 1 1 0 0"
	   "0 0 1 1 1 1 0 0"
	   "0 0 0 0 1 1 1 1" )

if [ $# -ne 1 ]; then
    echo ""
    echo "usage  : ./shutdowntest dcs0XYZ"
    echo ""
    exit;
fi

date=`/bin/date '+%Y%m%d-%H%M'`
LOGFILE=logs/shutdown-test-$date.log
#HOST=dcs$DCS_SERIAL
#DC_TYPE=$ROC_TYPE

LINK=0         # always use link 0 ???
NUMLINK=0
let NUMLINK=$DC_TYPE+3
LOOPS=0
let LOOPS=$NUMLINK+1

TEST=0
while [  $TEST -lt $LOOPS ]; do
    echo ""
    echo "${MESSAGE1[$TEST]}"
    ssh $HOST "/usr/local/sbin/rob_power ${POWERVAL[$TEST]};"
    # Reset is necessary because some chip goes undefined states after power up.
    ssh $HOST \
	" /usr/local/sbin/rob_reset; sleep 1; \
          /usr/local/sbin/rob_reset; sleep 1; \
          /usr/local/sbin/rob_reset; sleep 1; \
          /usr/local/sbin/rob_reset; sleep 1; \
          /usr/local/sbin/rob_reset; sleep 1"
    echo ""
    echo "########################################################################" | tee -a $LOGFILE
    echo "Ping all links. ${MESSAGE2[$TEST]}!" | tee -a $LOGFILE
    echo "########################################################################" | tee -a $LOGFILE
    do_ping
    let TEST=TEST+1
done


#echo ""
#echo -n "Shutdown test performed ok? (y/n) : "
#read OK
#if [ x$OK == "xy" ]; then
#    echo "$INITIAL says that test was performed OK on `date`" >> $LOGFILE
#    echo $OK >> $LOGFILE
#fi

echo "::Finished:: `date`"
echo ""

#echo "$date: Executed:shutdowntest.sh Result:$OK" >> $DIR_NAME/_history

# EOF
