#! /usr/bin/perl
#
# No argument is necessary.
#

if ( $#ARGV < 0 || $#ARGV > 1  ) {
    print "\n";
    print "usage: simple_interlock.pl no_layers (Tmax in K)\n";
    print "\n";
    print "One argument needed: Number of layers.\n";
    print "Optinal argument is maximum temperature (Default 305K).\n";
    print "\n";
    exit;
}

$TMAX=305;
if ( $#ARGV == 1 ) { $TMAX=$ARGV[1] }

$LAYERS=$ARGV[0];

printf("Maximum Temperature is set: %d K (%.1f C)\n\n", $TMAX, $TMAX - 273.15 );


do {
    open(FILE, " tail -1 temperatures.log 2>&1 | ");
    while(<FILE>) {
        if ( /.\d*\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)\s(\d*\.\d*)./ ) {

	    # print
	    my( @ttime ) = `date +%T`;
	    foreach( @ttime ) {
		chop;
		if ( /.*(\d\d:\d\d:\d\d).*/ ) {
		    print "$1:  ";
		}
	    }

	    ($avgtot, $min, $max)  = (0.0, 5000., -274.);

	    for ($L = 0; $L < $LAYERS; $L++) {
		$avg=0;
		for ($T = $L*5+1; $T <= $L*5+5; $T++) {
		    $avg += $$T;
		    $avgtot += $$T;
		    if( $$T > $max ) { $max = $$T; }
		    if( $$T < $min ) { $min = $$T; }
		}
		printf(" L%d: avg=%.1f |", $L, $avg/5.0 - 273.15);
	    }
	    printf( "|| AVG=%.1f MIN=%.1f MAX=%.1f |||\n", $avgtot/$LAYERS/5. - 273.15, $min - 273.15, $max - 273.15);
	    # check temperatures
	    for ($T = 1; $T <= $NUM; $T++) {       # Now: L0, L1, L2, L3, L4
		if ($$T > $TMAX) {
		    printf("Temperature is out of specified range! Switching all power off!\n");
		    system( "./power_all off" );   # all ROB Powers off
		    system( "./dcs-power off" );   # all DCS Powers off
		    exit;
		}
	    }
        } else {
	    printf("Funny numbers read from file temperatures.log!\n");
	}
    }

    sleep 11;

} while ( 1 ); 


# EOF
