#! /bin/sh
#
# Stress test script.
# Usage: stress_test.sh Duration Nruns

DURATION=$1
N_RUNS=$2

RSTATE_SM=./rstate_quick_sm

let testgood=`modules/check_ttcvi-seq.pl | tail -1`
if [ $testgood -eq 0 ]; then
    echo ""
    echo "Found running ttcvi-seq program on daq02."
    echo "Maybe other test stand is running?"
    echo "Please check."
    echo ""
    exit;
fi

. _setup.sh

date=`/bin/date '+%Y%m%d-%H%M'`
log_file=logs/stress-test-$date.log

I_RUN=1

echo "Checking status." | tee -a $log_file

$RSTATE_SM | tee -a $log_file

echo "Run $I_RUN / $N_RUNS" | tee -a $log_file

while [ $I_RUN -le $N_RUNS ]; do
    echo "" | tee -a $log_file
    echo "Run $I_RUN / $N_RUNS" | tee -a $log_file
    echo "Sending triggers for $DURATION [s]." | tee -a $log_file
    ssh daq02 ttcvi-seq src=7 ctr_reset ttcrx_ctr_reset report src=1 sleep=$DURATION src=7 report | tee -a $log_file

    echo "Checking status." | tee -a $log_file
    $RSTATE_SM | tee -a $log_file
    let I_RUN=I_RUN+1

done

echo "Done." | tee -a $log_file
